
reducedGoodFusion.df = read.csv("/Users/bolme/Documents/workspace/PythonFaceEvaluation/results/lrpca_rightocular_gbu_good_roc.csv")
reducedBadFusion.df = read.csv("/Users/bolme/Documents/workspace/PythonFaceEvaluation/results/lrpca_rightocular_gbu_bad_roc.csv")
reducedUglyFusion.df = read.csv("/Users/bolme/Documents/workspace/PythonFaceEvaluation/results/lrpca_rightocular_gbu_ugly_roc.csv")

names(reducedGoodFusion.df) = c('score','FRR','FAR','TRR','TAR')
names(reducedBadFusion.df) = c('score','FRR','FAR','TRR','TAR')
names(reducedUglyFusion.df) = c('score','FRR','FAR','TRR','TAR')

pdf(file="/Users/bolme/Documents/workspace/PythonFaceEvaluation/results/ROC_GBU_LRPCA_rightocular_withPoints.pdf",width=8,height=8)

par(mar=c(5,5,4,3)+0.1)

plot(.01,.98,type="n", xlim=c(0.001,1.0), ylim=c(0.0,1.0), xlab="False accept rate",ylab="Verification rate",log="x",lwd=2.5,xaxt="n",cex=1.5,cex.axis=1.5,cex.lab=1.5)

axis(1,labels=c("0.001","0.01","0.1","1.0"),at=c(0.001,0.01,0.1,1.0),cex.axis=1.5,cex.lab=1.5,las=1)

lines(reducedGoodFusion.df$FAR, reducedGoodFusion.df$TAR,col="black",lwd=2.5)
lines(reducedBadFusion.df$FAR, reducedBadFusion.df$TAR,col="red",lwd=2.5)
lines(reducedUglyFusion.df$FAR, reducedUglyFusion.df$TAR,col="blue",lwd=2.5)

legend("bottomright",legend=c("Good","Bad","Ugly"),col=c("black","red","blue"),bty="o",bg="white",lty=c("solid","solid","solid"),lwd=c(2.5,2.5,2.5),cex=1.5)

abline(v=0.001,col=c("darkgray"),lwd=c(2.5))

roc = splinefun(reducedUglyFusion.df$FAR,reducedUglyFusion.df$TAR)
points(c(0.001),c(roc(0.001)),col=c("black"),lwd=c(2),pch=19)
text(c(0.001)+0.0005,c(roc(0.001))-0.01,col=c("black"),label=sprintf("%.2f",roc(0.001)),cex=1.25)

roc = splinefun(reducedBadFusion.df$FAR,reducedBadFusion.df$TAR)
points(c(0.001),c(roc(0.001)),col=c("black"),lwd=c(2),pch=19)
text(c(0.001)+0.0005,c(roc(0.001))-0.01,col=c("black"),label=sprintf("%.2f",roc(0.001)),cex=1.25)

roc = splinefun(reducedGoodFusion.df$FAR,reducedGoodFusion.df$TAR)
points(c(0.001),c(roc(0.001)),col=c("black"),lwd=c(2),pch=19)
text(c(0.001)+0.0005,c(roc(0.001))-0.01,col=c("black"),label=sprintf("%.2f",roc(0.001)),cex=1.25)

#points(c(0.001),c(reducedBadFusion.df$TAR[which(reducedBadFusion.df$FAR==0.001)]),col=c("black"),lwd=c(2),pch=19)
#text(c(0.001)+0.0005,c(reducedBadFusion.df$TAR[which(reducedBadFusion.df$FAR==0.001)])-0.015,col=c("black"),label="0.80",cex=1.25)

#points(c(0.001),c(reducedGoodFusion.df$TAR[which(reducedGoodFusion.df$FAR==0.001)]),col=c("black"),lwd=c(2),pch=19)
#text(c(0.001)+0.0005,c(reducedGoodFusion.df$TAR[which(reducedGoodFusion.df$FAR==0.001)])-0.025,col=c("black"),label="0.98",cex=1.25)

dev.off()